{13}
{pouze crt,graph}

{Pozn. autora
a)Na konci je "pruvodce ovladanim"
b)
 Ukoly 7. - 9.
 Vzhledem k jejich skoro uplne podobnosti jsou reseny nasledovne:
 7.napoveda se vyvola "?" - zavola se procedura pocitac
 8. a 9. - pak-li zadate jen jednoho hrace jako "computer" bude splnen ukol
 8., pak-li zadate oba jako computerbude splnen ukol c.9
c)souradnice jsou zadavany zpusobem
  svisla/vodorovna
  jeji souradnice x ve svislych(je jich n+1)/vodorovnych(je jich n)
  jeji souradnice y ve svislych(je jich n)/vodorovnych(jejich n+1)
}

uses crt,graph;    {svisla/vodorovna,x sour,y sour}
type thdata=record s,x,y:byte; skore:byte; jmeno:string; end; {typ hrac}
     tskdata=array[1..10] of record jmeno:string; body:byte; end;{typ skore, v highscore tabulce}

const barvy:array[0..2] of byte=(darkgray,red,yellow);
      o:array[1..2] of byte=(2,1); {pomocna konstanta pro prehazovani hracu 1-2, 2-1}
      skorefile='highscor.dat';

var gd,gm:integer; {Promenne pro inicializaci grafiky}
    {pomocne promene}
    konec:boolean;
    n,en:byte; {en=n+1 .. kvuli dokoncenosi site, aby pole bylo v pravo a dole ohranicene}
    znak:char;
    {Pole na kterem se hraje}
    pole:array[1..2,1..11,1..11] of byte; {1..2 - svisla ci vodorovna?, 1..10,1..10 - x,y}
    ctverce:array[1..10,1..10] of byte;
    {hraci}
    h:byte; {hraje}
    hdata:array[1..2] of thdata;
    {kontrola konce}
    pocet,maxp:integer;
    {na zaklade pozn. c), muzeme rici, ze maximum je dvojnasobek (n+1)*n}
    {skore}
    skdata:tskdata;
    skfile:file of tskdata;
    {pocitac}
    ok:boolean;
    kamx,kamy,jakou:byte;
    pocbodu:byte;
    doba:integer;
    {Konec definice promennych}



procedure rozmery;    {Puvodne jen zadani rozmeru, nyni +nacitani jmena a inicializace}
var i,j:byte;
    p:boolean;
begin
  clrscr;
  write('Rozmery pole?:');
  readln(n);
  pocet:=0;
  maxp:=2*(n*(n+1));
  if n<2 then n:=2;
  if n>10 then n:=10;
  en:=n+1;

  for i:=1 to en do
  for j:=1 to en do
  begin
    pole[1,i,j]:=0;
    pole[2,i,j]:=0;
  end;
  for i:=1 to n do
  for j:=1 to n do
  begin
    ctverce[i,j]:=0;
  end;
  writeln('Zadateli "computer", bude hrat pocitac.(Za hrace, ktereho jste tak zadali)');
  p:=false;
  for i:=1 to 2 do
  begin
    write('Jmeno hrace c.',i,':');
    readln(hdata[i].jmeno);
    if hdata[i].jmeno='computer' then p:=true;
  end;
  doba:=300;
  writeln('At hraji za kterehokoliv hrace, stale jsem v highscore jako computer');
  writeln('Vzhledem k tomu, ze jste zadal, aby hral i pocitac, musite zadat prodlevu.');
  write('Prodleva tahu v mikrosekundach:');
  readln(doba);
end;


procedure grzacni;
begin
  gd:=0;
  initgraph(gd,gm,'g:\bgi');
end;
procedure grskonci;
begin
  closegraph;
end;

procedure zob_pole; {zobrazeni hraciho pole}
var x,y,s:byte;
begin
  for x:=1 to n do
  for y:=1 to n do
  begin
    begin
      setcolor(barvy[pole[1,x,y]]);
      line(x*10,y*10,x*10,y*10+10);
    end;
    begin
      setcolor(barvy[pole[2,x,y]]);
      line(x*10,y*10,x*10+10,y*10);
    end;
  end;
  {Ted jeste pole uzavreme}
  for y:=1 to n do
  begin
    setcolor(barvy[pole[1,x+1,y]]);
    line((n+1)*10,y*10,(n+1)*10,y*10+10);
  end;
  for x:=1 to n do
  begin
    setcolor(barvy[pole[2,x,y+1]]);
    line(x*10,(n+1)*10,x*10+10,(n+1)*10);
  end;
  for x:=1 to n do {Vypln obsazeneho ctverce}
  for y:=1 to n do
  begin
    putpixel(x*10+5,y*10+5,barvy[ctverce[x,y]]);
    putpixel(x*10+5,y*10+6,barvy[ctverce[x,y]]);
    putpixel(x*10+6,y*10+5,barvy[ctverce[x,y]]);
    putpixel(x*10+6,y*10+6,barvy[ctverce[x,y]]);
  end;
end;

procedure zobhrace; {zobrazeni aktualni pozice hrace}
begin
  setcolor(barvy[h]);
  if pole[hdata[h].s,hdata[h].x,hdata[h].y]=0 then
  begin
    case hdata[h].s of
    1:line(hdata[h].x*10,hdata[h].y*10,hdata[h].x*10,hdata[h].y*10+10);
    2:line(hdata[h].x*10,hdata[h].y*10,hdata[h].x*10+10,hdata[h].y*10);
    end;
  end;
  if pole[hdata[h].s,hdata[h].x,hdata[h].y]<>0 then  {Kdyby na tech souradnicich uz neco bylo, tak se posun, abys videl}
  begin
    case hdata[h].s of
    1:line(hdata[h].x*10+1,hdata[h].y*10+1,hdata[h].x*10+1,hdata[h].y*10+10-1);
    2:line(hdata[h].x*10+1,hdata[h].y*10+1,hdata[h].x*10+10-1,hdata[h].y*10+1);
    end;
  end;
end;
procedure zhashrace; {Zhasnuti ukazovatka, podobna konstrukce jako predesla procedura}
begin
  if pole[hdata[h].s,hdata[h].x,hdata[h].y]=0 then
  begin
    setcolor(barvy[0]);
    case hdata[h].s of
    1:line(hdata[h].x*10,hdata[h].y*10,hdata[h].x*10,hdata[h].y*10+10);
    2:line(hdata[h].x*10,hdata[h].y*10,hdata[h].x*10+10,hdata[h].y*10);
    end;
  end;
  if pole[hdata[h].s,hdata[h].x,hdata[h].y]<>0 then
  begin
    setcolor(0);
    case hdata[h].s of
    1:line(hdata[h].x*10+1,hdata[h].y*10+1,hdata[h].x*10+1,hdata[h].y*10+10-1);
    2:line(hdata[h].x*10+1,hdata[h].y*10+1,hdata[h].x*10+10-1,hdata[h].y*10+1);
    end;
  end;
end;

procedure kontroluj; {zjisti, zda kdyz jsem polozil sirku, dostanu bod?, bude ctverec muj?}
{}
procedure ksvisl; {Kdyz bude polozena sirka svisla}
begin
  if hdata[h].x>1 then
  begin
    if pole[1,hdata[h].x-1,hdata[h].y]=h then
     if pole[2,hdata[h].x-1,hdata[h].y]=h then
      if pole[2,hdata[h].x-1,hdata[h].y+1]=h then
      begin
        ctverce[hdata[h].x-1,hdata[h].y]:=h;
        inc(hdata[h].skore);
      end;
  end;
  if hdata[h].x<en then
  begin
    if pole[1,hdata[h].x+1,hdata[h].y]=h then
     if pole[2,hdata[h].x,hdata[h].y]=h then
      if pole[2,hdata[h].x,hdata[h].y+1]=h then
      begin
        ctverce[hdata[h].x,hdata[h].y]:=h;
        inc(hdata[h].skore);
      end;
  end;
end;
procedure kvodor; {kdyz bude polozena sirka vodorovna}
begin
  if hdata[h].y>1 then
  begin
    if pole[2,hdata[h].x,hdata[h].y-1]=h then
     if pole[1,hdata[h].x,hdata[h].y-1]=h then
      if pole[1,hdata[h].x+1,hdata[h].y-1]=h then
      begin
        ctverce[hdata[h].x,hdata[h].y-1]:=h;
        inc(hdata[h].skore);
      end;
  end;
  if hdata[h].y<en then
  begin
    if pole[2,hdata[h].x,hdata[h].y+1]=h then
     if pole[1,hdata[h].x,hdata[h].y]=h then
      if pole[1,hdata[h].x+1,hdata[h].y]=h then
      begin
        ctverce[hdata[h].x,hdata[h].y]:=h;
        inc(hdata[h].skore);
      end;
  end;
end;
{}
begin
  case hdata[h].s of
  1:ksvisl; {kontrola kdyz polozim svislou}
  2:kvodor; {kontrola kdyz polozim vodorovnou}
  end;
end;

procedure skore; {prubezne zobrazujeme skore}
var i:byte;
    r:string;
begin
  setfillstyle(1,green);
  bar(1,400,100,480);
  for i:=1 to 2 do
  begin
    setcolor(barvy[i]);
    str(hdata[i].skore,r);
    outtextxy(20,370+i*40,r);
  end;
end;

procedure highscore; {highscore, zmeny uvidime az pri pristi hre}
var i:byte;
    r:string;
begin
  for i:=1 to 10 do begin skdata[i].jmeno:='...'; skdata[i].body:=0; end;
  assign(skfile,skorefile);
  {$I-}
  reset(skfile);
  read(skfile,skdata);
  close(skfile);
  {$I+}
  if ioresult<>0 then
  begin
  rewrite(skfile);
  close(skfile);
  end;
  for i:=1 to 10 do
  begin
    setcolor(yellow);
    str(i,r); r:=r+'.';
    outtextxy(470,i*20,r);
    str(skdata[i].body,r);
    setcolor(white);
    outtextxy(500,i*20,skdata[i].jmeno);
    outtextxy(600,i*20,r);
  end;
end;

procedure provedzapis; {je konec hry a ja pripadne zmenim highscore tabulku}
procedure htabulka(jm:string; b:byte);
var misto,i:byte;
begin
  misto:=11;
  while (skdata[misto].body<b) and (misto>0) do dec(misto);
  inc(misto);
  if misto<11 then
  begin
    if misto<10 then
    for i:=9 downto misto do
    skdata[i+1]:=skdata[i];
    skdata[misto].jmeno:=jm; skdata[misto].body:=b;
  end;
end;
begin
  htabulka(hdata[1].jmeno,hdata[1].skore);
  htabulka(hdata[2].jmeno,hdata[2].skore);
  rewrite(skfile);
  reset(skfile);
  write(skfile,skdata);
  close(skfile);
end;

{------------Pocitac}
procedure pkontroluj(kx,ky,s,h:byte);
{}
procedure ksvisl;
begin
  if kx>1 then
  begin
    if pole[1,kx-1,ky]=h then
     if pole[2,kx-1,ky]=h then
      if pole[2,kx-1,ky+1]=h then
      begin
        inc(pocbodu);
      end;
  end;
  if kx<en then
  begin
    if pole[1,kx+1,ky]=h then
     if pole[2,kx,ky]=h then
      if pole[2,kx,ky+1]=h then
      begin
        inc(pocbodu);
      end;
  end;
end;
procedure kvodor;
begin
  if ky>1 then
  begin
    if pole[2,kx,ky-1]=h then
     if pole[1,kx,ky-1]=h then
      if pole[1,kx+1,ky-1]=h then
      begin
        inc(pocbodu);
      end;
  end;
  if ky<en then
  begin
    if pole[2,kx,ky+1]=h then
     if pole[1,kx,ky]=h then
      if pole[1,kx+1,ky]=h then
      begin
        inc(pocbodu);
      end;
  end;
end;
{}
begin
  pocbodu:=0;
  case s of
  1:ksvisl; {kontrola kdyz polozim svislou}
  2:kvodor; {kontrola kdyz polozim vodorovnou}
  end;
end;

procedure vyhnejtah(koho,kdo:byte);
var nx,ny,nj,nb:byte;
begin
  nx:=1;
  ny:=1;
  nj:=1;
  nb:=0;
  for jakou:=1 to 2 do
  case jakou of
  1:
  for kamx:=1 to en do
  for kamy:=1 to n do
  if pole[jakou,kamx,kamy]=0 then
  begin
    pkontroluj(kamx,kamy,jakou,koho);
    if pocbodu>nb then
    begin
      nx:=kamx;
      ny:=kamy;
      nb:=pocbodu;
      nj:=jakou;
    end;
  end;
  2:
  for kamx:=1 to n do
  for kamy:=1 to en do
  if pole[jakou,kamx,kamy]=0 then
  begin
    pkontroluj(kamx,kamy,jakou,koho);
    if pocbodu>nb then
    begin
      nx:=kamx;
      ny:=kamy;
      nb:=pocbodu;
      nj:=jakou;
    end;
  end;
  end;
  if nb>0 then
  begin
    pole[nj,nx,ny]:=h;
    hdata[kdo].x:=nx;
    hdata[kdo].y:=ny;
    hdata[kdo].s:=nj;
    kontroluj;
    zob_pole;
    h:=o[h];
    skore;
    ok:=true;
    inc(pocet);
  end;
end;

procedure polozvedle(koho:byte); {poloz vedle koho?}
begin
end;

procedure vylosuj(ci:byte); {ci bude losovana zapalka}
var rx,ry:byte;
begin
  while pole[jakou,kamx,kamy]<>0 do
  begin
    jakou:=random(2)+1;
    rx:=n;
    ry:=n;
    if jakou=1 then rx:=en;
    if jakou=2 then ry:=en;
    kamx:=random(rx)+1;
    kamy:=random(ry)+1;
  end;
    pole[jakou,kamx,kamy]:=ci;
    hdata[ci].x:=kamx;
    hdata[ci].y:=kamy;
    hdata[ci].s:=jakou;
    kontroluj;
    zob_pole;
    h:=o[h];
    skore;
    ok:=true;
    inc(pocet);
end;


procedure pocitac;
begin
  ok:=false; {deklarace procedure vyhnejtah(pro koho je nejvyhodnejsi, ci ta sirka bude)}
  vyhnejtah(h,h); {Najdi pro mne ten nejvyhodnejsi tah}  {Spravne - Vyhledej nejlepsi tah, nikoliv vyhnej tah}
  if not ok then vyhnejtah(o[h],h); {Kdyz nemuzu ja, zjisti zda mu to muzu zkazit}
{  if not ok then polozvedle(h); {Kdyz mu to nelze zkazit, najdi nejakou mou sirku a poloz vedle}
{Pravdepodobne nefunkcni.. preskoceno}
  if not ok then vylosuj(h); {kdyz nemam sirku, tak si ji nekam dame}
  delay(doba);
end;
{Konec pocitac------------------}

begin
  randomize;
  rozmery;
  grzacni;
  highscore;
  konec:=false;
  zob_pole;
  h:=1;
  hdata[h].x:=1;
  hdata[h].y:=1;
  hdata[h].s:=1;
  hdata[h].skore:=0;
  h:=2;
  hdata[h].x:=1;
  hdata[h].y:=1;
  hdata[h].s:=1;
  hdata[h].skore:=0;
  h:=1;
  skore;
  repeat
  if hdata[h].jmeno<>'computer' then
  begin
  zobhrace;
  znak:=readkey;
  zhashrace;
  case znak of
  '1':begin hdata[h].s:=1; if hdata[h].y=en then dec(hdata[h].y); end;
  '2':begin hdata[h].s:=2; if hdata[h].x=en then dec(hdata[h].x); end;
  #80:
      begin
        if hdata[h].s=1 then if hdata[h].y<n then inc(hdata[h].y);
        if hdata[h].s=2 then if hdata[h].y<en then inc(hdata[h].y);
      end;
  #72:
      begin
        if hdata[h].y>1 then dec(hdata[h].y);
      end;
  #77:
      begin
        if hdata[h].s=1 then if hdata[h].x<en then inc(hdata[h].x);
        if hdata[h].s=2 then if hdata[h].x<n then inc(hdata[h].x);
      end;
  #75:
      begin
        if hdata[h].x>1 then dec(hdata[h].x);
      end;
  #27:konec:=true;
  #13:begin
        if pole[hdata[h].s,hdata[h].x,hdata[h].y]=0 then
           begin
             sound(1000); delay(50); nosound; pole[hdata[h].s,hdata[h].x,hdata[h].y]:=h;
             kontroluj; inc(pocet); zob_pole; h:=o[h]; skore;
           end;
      end;
  '?':pocitac;
  end;
  end else pocitac;
  if maxp=pocet then konec:=true; {Uz je plno?}
  until konec;
  grskonci;
  provedzapis;
end.
{ Pruvodce ovladanim  }
(*
Svoji sirkou pohybujete sipkami,
pokud ji chcete zmenit na svislou stiknete "1"
pokud ji chcete zmenit na vodorovnou stisknete "2"
sirku polozite klavesou "Enter"
konec programu "Esc"
napomoc od pocitace "?"
*)
{Tento program 1244 znaku.}